"use strict";

var esprima = _interopRequireWildcard(require("esprima"));
var _escodegen = _interopRequireDefault(require("escodegen"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
let start = {
  type: 'ExpressionStatement',
  expression: {
    type: 'CallExpression',
    callee: {
      type: 'MemberExpression',
      computed: false,
      object: {
        type: 'MemberExpression',
        computed: false,
        object: {
          type: 'MemberExpression',
          computed: false,
          object: {
            type: 'Identifier',
            name: 'window'
          },
          property: {
            type: 'Identifier',
            name: 'ClientCoverage'
          }
        },
        property: {
          type: 'Identifier',
          name: 'JS'
        }
      },
      property: {
        type: 'Identifier',
        name: 'visitMethod'
      }
    },
    arguments: [{
      type: 'Literal',
      value: 'filename',
      raw: '\'filename\''
    }, {
      type: 'Literal',
      value: 'functionName',
      raw: '\'functionName\''
    }]
  }
};
let scriptInstrumentLoader = function (source) {
  let parsed = esprima.parseModule(source, {
    jsx: true
  });
  for (let i in parsed.body) {
    if (parsed.body[i].type === 'FunctionDeclaration' || parsed.body[i].type === 'ExportDefaultDeclaration' || parsed.body[i].type === 'ExportNamedDeclaration') {
      let ParsedTemp;
      if (parsed.body[i].type === 'FunctionDeclaration') {
        ParsedTemp = parsed.body[i];
      } else {
        ParsedTemp = parsed.body[i].declaration;
      }
      if (ParsedTemp) {
        if (ParsedTemp.id) {
          let funcname = ParsedTemp.id.name;
          if (funcname !== 'mapStateToProps') {
            if (!funcname.includes('_')) {
              let startFunc = JSON.parse(JSON.stringify(start));
              startFunc.expression.arguments[0].value = this.resourcePath;
              startFunc.expression.arguments[0].raw = this.resourcePath;
              startFunc.expression.arguments[1].value = funcname;
              startFunc.expression.arguments[1].raw = funcname;
              ParsedTemp.body.body.unshift(startFunc);
            }
          }
        }
      }
    }
  }
  return _escodegen.default.generate(parsed);
  // function removeDuplicates(arr) {
  //   let uniqueArray = [];
  //   for (let i = 0; i < arr.length; i++) {
  //     if (uniqueArray.indexOf(arr[i]) == -1) {
  //       uniqueArray.push(arr[i]);
  //     }
  //   }
  //   return uniqueArray;
  // }
  // funcArray = removeDuplicates(funcArray);
};
module.exports = scriptInstrumentLoader;

// let start = {
//   type: 'ExpressionStatement',
//   expression: {
//     type: 'CallExpression',
//     callee: {
//       type: 'Identifier',
//       name: 'getMethodName'
//     },
//     arguments: [
//       {
//         type: 'Literal',
//         value: 'filename',
//         raw: '"filename"'
//       },
//       {
//         type: 'Literal',
//         value: 'functionname',
//         raw: '"functionname"'
//       }
//     ]
//   }
// };