"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getLibraryImactPlugins;
var _libraryImpactPlugin = _interopRequireDefault(require("../plugins/libraryImpactPlugin"));
var _getDocsPlugins = _interopRequireDefault(require("./getDocsPlugins"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
// import ModuleStatsPlugin from '../plugins/ModuleStatsPlugin';

function getLibraryImactPlugins(options) {
  let plugins = (0, _getDocsPlugins.default)(false, options, true);

  // for performance But for furture maintanablity we adding isForLibraryImpact in getDocsPlugin
  // plugins.filter(plugin => !(plugin instanceof ModuleStatsPlugin));

  plugins.push(new _libraryImpactPlugin.default({
    filename: 'js/libraryImpact.js'
  }));
  return plugins;
}