"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _caseSensitivePathsWebpackPlugin = _interopRequireDefault(require("case-sensitive-paths-webpack-plugin"));
var _webpack = _interopRequireDefault(require("webpack"));
var _miniCssExtractPlugin = _interopRequireDefault(require("mini-css-extract-plugin"));
var _plugins = require("../plugins");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
let getUMDComponentPlugins = isDocs => {
  let plugins = [new _caseSensitivePathsWebpackPlugin.default(), new _webpack.default.DefinePlugin({
    __TEST__: false,
    __DEVELOPMENT__: false,
    __DOCS__: isDocs ? true : false,
    'process.env': {
      NODE_ENV: JSON.stringify('production')
    },
    __SERVER__: false
  }), new _miniCssExtractPlugin.default({
    filename: 'css/[name].css',
    chunkFilename: 'css/[name].css'
  }), new _plugins.MinifyPlugin()];
  return plugins;
};
var _default = exports.default = getUMDComponentPlugins;