"use strict";

// // const { getAllI18nGroupedBySection, getPropertiesAsJSON } = require('../I18nSplitPlugin/utils/propertiesUtils');
// // const { collectI18nKeysfromAST, collectI18nKeysfromComments } = require('../I18nSplitPlugin/utils/collectI18nKeys');
// // const NullFactory = require('webpack/lib/NullFactory');
// // const { I18nDependency, I18nDependencyTemplate } = require('../I18nSplitPlugin/I18nDependency');
// // const { RawSource } = require('webpack-sources');
// // const crypto = require('crypto');
// // const escodegen = require('escodegen');
// // const pluginName = 'I18nPlugin';
// // const esprima = require('esprima');
// // class I18nPlugin {
// //   constructor(options = {}) {
// //     const { jsResourcePath, mainChunkName, propertiesFolder, disableDefault, jsResource } = options;
// //     if (!jsResourcePath) {
// //       throw new Error('I18nPlugin: "jsResourcePath" option is required.');
// //     }
// //     if (!mainChunkName) {
// //       throw new Error('I18nPlugin: "mainChunkName" option is required.');
// //     }
// //     this.jsResourcePath = jsResourcePath;
// //     this.entryPointName = mainChunkName;
// //     this.jsResourceI18nKeys = jsResource ? getPropertiesAsJSON(jsResource) : {};
// //     // Use getAllI18nGroupedBySection to group keys by sections
// //     this.allI18nKeys = getAllI18nGroupedBySection({
// //       folderPath: propertiesFolder,
// //       disableDefault,
// //       jsResourceI18nKeys: this.jsResourceI18nKeys,
// //     });
// //     console.log('Locales found:', Object.keys(this.allI18nKeys));
// //     // Build keyToSectionMap
// //     this.keyToSectionMap = {};
// //     const locales = Object.keys(this.allI18nKeys);
// //     if (locales.length > 0) {
// //       // Use the first locale to build keyToSectionMap
// //       const firstLocale = locales[0];
// //       const sections = this.allI18nKeys[firstLocale];
// //       console.log(`Sections found in properties files: ${Object.keys(sections).join(', ')}`);
// //       for (const sectionName of Object.keys(sections)) {
// //         const keysInSection = sections[sectionName];
// //         for (const key of Object.keys(keysInSection)) {
// //           this.keyToSectionMap[key] = sectionName;
// //         }
// //       }
// //     }
// //     this.moduleToKeysMap = new Map();
// //     this.keyToModulesMap = new Map();
// //     this.keyToI18nChunkIdMap = {};
// //     // Initialize keyToHashMap and getHash function
// //     this.keyToHashMap = {};
// //     this.getHash = (key) => {
// //       if (!this.keyToHashMap[key]) {
// //         const hash = crypto.createHash('md5').update(key).digest('hex').substring(0, 8);
// //         this.keyToHashMap[key] = hash;
// //       }
// //       return this.keyToHashMap[key];
// //     };
// //     // Process allI18nKeys to replace keys with hashes
// //     for (const locale of locales) {
// //       const sections = this.allI18nKeys[locale];
// //       for (const sectionName in sections) {
// //         const section = sections[sectionName];
// //         const newSection = {};
// //         for (const key in section) {
// //           const hash = this.getHash(key);
// //           newSection[hash] = section[key];
// //         }
// //         sections[sectionName] = newSection;
// //       }
// //     }
// //   }
// //   defineI18nDependency(compilation) {
// //     compilation.dependencyFactories.set(I18nDependency, new NullFactory());
// //     compilation.dependencyTemplates.set(I18nDependency, new I18nDependencyTemplate());
// //   }
// //   apply(compiler) {
// //     compiler.hooks.thisCompilation.tap(pluginName, (compilation, params) => {
// //       this.defineI18nDependency(compilation);
// //       // Handler for parser
// //       const handler = parser => {
// //         parser.hooks.program.tap(pluginName, (ast, comments) => {
// //           const { module } = parser.state;
// //           if (!(module && /\.jsx?$/.test(module.resource))) {
// //             return;
// //           }
// //           // Collect and replace i18n keys
// //           let i18nKeys = collectI18nKeysfromAST(ast, this.jsResourceI18nKeys, this.getHash);
// //         //  let commentKeys = collectI18nKeysfromComments(comments, this.jsResourceI18nKeys);
// //          // i18nKeys = i18nKeys.concat(commentKeys);
// //           if (i18nKeys.length) {
// //             try {
// //                 const code = escodegen.generate(ast, { comment: true });
// //                 // Update the module's source code
// //                 module._source._value = code;
// //               } catch (error) {
// //                 console.error(`Syntax error in generated code for module ${module.resource}:`, error);
// //               }
// //             // const code = escodegen.generate(ast, { comment: true });
// //             // module._source._value = code;
// //             // Store the hashed keys for this module
// //             const hashedKeys = i18nKeys.map(key => this.getHash(key));
// //             this.moduleToKeysMap.set(module.resource, hashedKeys);
// //             // Map hashed keys to modules
// //             for (const hash of hashedKeys) {
// //               if (!this.keyToModulesMap.has(hash)) {
// //                 this.keyToModulesMap.set(hash, new Set());
// //               }
// //               this.keyToModulesMap.get(hash).add(module.resource);
// //             }
// //           }
// //         });
// //       };
// //       const factory = params.normalModuleFactory;
// //       factory.hooks.parser.for('javascript/auto').tap(pluginName, handler);
// //       factory.hooks.parser.for('javascript/dynamic').tap(pluginName, handler);
// //       compilation.hooks.afterOptimizeChunks.tap(pluginName, () => {
// //         this.processCollectedKeys(compilation);
// //       });
// //     });
// //   }
// //   processCollectedKeys(compilation) {
// //     // Map to store chunkId to required sections
// //     this.chunkIdToSectionsMap = {};
// //     this.moduleChunkIdToModulesMap = {};
// //     // Map module resource to chunk IDs
// //     this.moduleResourceToChunkIds = new Map();
// //     // Collect modules for the entry point
// //     const entryPointChunk = compilation.namedChunks.get(this.entryPointName);
// //     const entryPointModules = new Set();
// //     if (entryPointChunk) {
// //       for (const module of entryPointChunk.getModules()) {
// //         if (module.resource) {
// //           entryPointModules.add(module.resource);
// //         }
// //       }
// //     }
// //     // Iterate over all chunks in the compilation
// //     for (const chunk of compilation.chunks) {
// //       const chunkId = chunk.name || chunk.id;
// //       const chunkIdString = String(chunkId);
// //       // Collect all modules in the chunk
// //       const modules = chunk.getModules();
// //       let requiredSections = new Set();
// //       let moduleResources = [];
// //       for (const module of modules) {
// //         const moduleResource = module.resource;
// //         if (moduleResource) {
// //           moduleResources.push(moduleResource);
// //           const keys = this.moduleToKeysMap.get(moduleResource);
// //           if (keys) {
// //             for (const key of keys) {
// //               const section = this.keyToSectionMap[key];
// //               if (section) {
// //                 requiredSections.add(section);
// //               }
// //             }
// //           }
// //           // Map module resource to chunk IDs
// //           if (!this.moduleResourceToChunkIds.has(moduleResource)) {
// //             this.moduleResourceToChunkIds.set(moduleResource, new Set());
// //           }
// //           this.moduleResourceToChunkIds.get(moduleResource).add(chunkIdString);
// //         }
// //       }
// //       // Store in the map if there are required sections
// //       if (requiredSections.size > 0) {
// //         this.chunkIdToSectionsMap[chunkIdString] = Array.from(requiredSections);
// //       }
// //       // Map chunkId to module resources
// //       if (moduleResources.length > 0) {
// //         this.moduleChunkIdToModulesMap[chunkIdString] = moduleResources;
// //       }
// //     }
// //     // Collect all used keys
// //     this.allUsedKeys = new Set();
// //     for (const keys of this.moduleToKeysMap.values()) {
// //       for (const key of keys) {
// //         this.allUsedKeys.add(key);
// //       }
// //     }
// //     // Collect entry point keys
// //     this.entryPointKeys = new Set();
// //     for (const moduleResource of entryPointModules) {
// //       const keys = this.moduleToKeysMap.get(moduleResource);
// //       if (keys) {
// //         for (const key of keys) {
// //           this.entryPointKeys.add(key);
// //         }
// //       }
// //     }
// //     // Collect unused keys
// //     this.allKeysInProperties = new Set();
// //     const firstLocale = Object.keys(this.allI18nKeys)[0];
// //     const sections = this.allI18nKeys[firstLocale];
// //     for (const section of Object.values(sections)) {
// //       for (const key of Object.keys(section)) {
// //         this.allKeysInProperties.add(key);
// //       }
// //     }
// //     this.unusedKeys = new Set([...this.allKeysInProperties].filter(key => !this.allUsedKeys.has(key)));
// //     // Remove entry point keys from allUsedKeys
// //     this.remainingKeys = new Set([...this.allUsedKeys].filter(key => !this.entryPointKeys.has(key)));
// //     // Emit the i18n chunks
// //     this.emitI18nChunks(compilation);
// //   }
// //   getValueForKeyInLocale(key, locale) {
// //     const sections = this.allI18nKeys[locale];
// //     for (const sectionName in sections) {
// //       const section = sections[sectionName];
// //       if (key in section) {
// //         return section[key];
// //       }
// //     }
// //     return undefined;
// //   }
// //   emitI18nChunks(compilation) {
// //     const manifest = {
// //       moduleToI18nChunkMap: {},
// //       locales: {},
// //     };
// //     // Get the list of locales
// //     const locales = Object.keys(this.allI18nKeys);
// //     const firstLocale = locales[0];
// //     // Map from i18nChunkId to keys
// //     const i18nChunkIdToKeysMap = {};
// //     let i18nChunkIdCounter = 0;
// //     // **Chunk 0**: Entry Point Keys
// //     const entryPointChunkId = i18nChunkIdCounter++;
// //     i18nChunkIdToKeysMap[entryPointChunkId] = Array.from(this.entryPointKeys);
// //     for (const key of this.entryPointKeys) {
// //       this.keyToI18nChunkIdMap[key] = entryPointChunkId;
// //     }
// //     // **Last Chunk**: Unused Keys
// //     const unusedKeysChunkId = 'unused'; // Using a string to make it distinct
// //     i18nChunkIdToKeysMap[unusedKeysChunkId] = Array.from(this.unusedKeys);
// //     // Remaining Keys: Group into chunks of ~30KB
// //     let currentChunkKeys = [];
// //     let currentChunkSize = 0;
// //     const desiredChunkSize = 100* 1024; // 30KB
// //     for (const key of this.remainingKeys) {
// //       const value = this.getValueForKeyInLocale(key, firstLocale);
// //       const keySize = Buffer.byteLength(key, 'utf8') + Buffer.byteLength(value || '', 'utf8');
// //       if (currentChunkSize + keySize > desiredChunkSize) {
// //         // Assign current chunk
// //         const i18nChunkId = i18nChunkIdCounter++;
// //         i18nChunkIdToKeysMap[i18nChunkId] = currentChunkKeys;
// //         // Map keys to i18nChunkId
// //         for (const chunkKey of currentChunkKeys) {
// //           this.keyToI18nChunkIdMap[chunkKey] = i18nChunkId;
// //         }
// //         // Start a new chunk
// //         currentChunkKeys = [];
// //         currentChunkSize = 0;
// //       }
// //       currentChunkKeys.push(key);
// //       currentChunkSize += keySize;
// //     }
// //     // Assign the remaining keys
// //     if (currentChunkKeys.length > 0) {
// //       const i18nChunkId = i18nChunkIdCounter++;
// //       i18nChunkIdToKeysMap[i18nChunkId] = currentChunkKeys;
// //       // Map keys to i18nChunkId
// //       for (const chunkKey of currentChunkKeys) {
// //         this.keyToI18nChunkIdMap[chunkKey] = i18nChunkId;
// //       }
// //     }
// //     // Now, generate the i18n chunks for each locale
// //     for (const locale of locales) {
// //       manifest.locales[locale] = manifest.locales[locale] || {};
// //       for (const [i18nChunkId, keys] of Object.entries(i18nChunkIdToKeysMap)) {
// //         const i18nData = {};
// //         for (const key of keys) {
// //           const value = this.getValueForKeyInLocale(key, locale);
// //           if (value !== undefined) {
// //             i18nData[key] = value;
// //           }
// //         }
// //         if (Object.keys(i18nData).length > 0) {
// //           const moduleSource = `window.loadI18nChunk(${JSON.stringify(i18nData, null, 2)});`;
// //           const filename = `i18n-chunks/${locale}/chunk-${i18nChunkId}.js`;
// //           compilation.emitAsset(filename, new RawSource(moduleSource));
// //           manifest.locales[locale][i18nChunkId] = filename;
// //           console.log(`Emitted i18n chunk: ${filename}`);
// //         }
// //       }
// //     }
// //     // Now, create moduleToI18nChunkMap
// //     for (const [moduleChunkId, moduleResources] of Object.entries(this.moduleChunkIdToModulesMap)) {
// //       const requiredI18nChunkIds = new Set();
// //       for (const moduleResource of moduleResources) {
// //         const keys = this.moduleToKeysMap.get(moduleResource);
// //         if (keys) {
// //           for (const key of keys) {
// //             const i18nChunkId = this.keyToI18nChunkIdMap[key];
// //             if (i18nChunkId !== undefined) {
// //               requiredI18nChunkIds.add(i18nChunkId);
// //             }
// //           }
// //         }
// //       }
// //       if (requiredI18nChunkIds.size > 0) {
// //         manifest.moduleToI18nChunkMap[moduleChunkId] = Array.from(requiredI18nChunkIds);
// //       } else {
// //         console.log(`No required i18n chunks for module chunk ID ${moduleChunkId}`);
// //       }
// //     }
// //     // Ensure that the main chunk always requires chunk zero
// //     manifest.moduleToI18nChunkMap[this.entryPointName] = manifest.moduleToI18nChunkMap[this.entryPointName] || [];
// //     if (!manifest.moduleToI18nChunkMap[this.entryPointName].includes(entryPointChunkId)) {
// //       manifest.moduleToI18nChunkMap[this.entryPointName].unshift(entryPointChunkId);
// //     }
// //     // Emit the manifest file
// //     const manifestSource = new RawSource(
// //       `window.i18n = window.i18n || {}; window.i18n.manifest = ${JSON.stringify(manifest, null, 2)};`
// //     );
// //     const manifestFilename = 'i18n-chunks/manifest.js';
// //     compilation.emitAsset(manifestFilename, manifestSource);
// //     console.log(`Emitted i18n manifest: ${manifestFilename}`);
// //   }
// // }
// // module.exports = I18nPlugin;
// const { getAllI18nGroupedBySection, getPropertiesAsJSON } = require('../I18nSplitPlugin/utils/propertiesUtils');
// const { collectI18nKeysfromAST, collectI18nKeysfromComments } = require('../I18nSplitPlugin/utils/collectI18nKeys');
// const { I18nDependency, I18nDependencyTemplate } = require('../I18nSplitPlugin/I18nDependency');
// const { RawSource } = require('webpack-sources');
// const crypto = require('crypto');
// const escodegen = require('escodegen');
// const esprima = require('esprima');
// const NullFactory = require('webpack/lib/NullFactory');
// const { walk } = require('estree-walker');
// // const pluginName = 'I18nPlugin';
// // class I18nPlugin {
// //     constructor(options = {}) {
// //       const { jsResourcePath, mainChunkName, propertiesFolder, disableDefault, jsResource } = options;
// //       if (!jsResourcePath) {
// //         throw new Error('I18nPlugin: "jsResourcePath" option is required.');
// //       }
// //       if (!mainChunkName) {
// //         throw new Error('I18nPlugin: "mainChunkName" option is required.');
// //       }
// //       this.jsResourcePath = jsResourcePath;
// //       this.entryPointName = mainChunkName;
// //       this.jsResourceI18nKeys = jsResource || {};
// //       // Initialize collection maps
// //       this.moduleToKeysMap = new Map();
// //       this.keyToModulesMap = new Map();
// //       this.keyToI18nChunkIdMap = {};
// //       this.keyToHashMap = {};
// //       // Initialize hash function
// //       this.getHash = (key) => {
// //         if (!this.keyToHashMap[key]) {
// //           const hash = crypto.createHash('md5').update(key).digest('hex').substring(0, 8);
// //           this.keyToHashMap[key] = hash;
// //         }
// //         return this.keyToHashMap[key];
// //       };
// //     }
// //     // Process source code and collect i18n keys
// //     processModule(module) {
// //       if (!module.resource || !module.resource.endsWith('.js')) {
// //         return [];
// //       }
// //       try {
// //         const source = module._source._value;
// //         // Parse the source code
// //         const ast = esprima.parse(source, {
// //           comment: true,
// //           tokens: true,
// //           range: true,
// //           loc: true
// //         });
// //         const i18nKeys = new Set();
// //         // Process the AST
// //         walk(ast, {
// //           enter: (node) => {
// //             if (node.type === 'Literal' && typeof node.value === 'string') {
// //               const key = node.value;
// //               if (Object.prototype.hasOwnProperty.call(this.jsResourceI18nKeys, key)) {
// //                 i18nKeys.add(key);
// //                 const hash = this.getHash(key);
// //                 node.value = hash;
// //                 node.raw = `'${hash}'`;
// //               }
// //             }
// //           }
// //         });
// //         // Generate modified code if keys were found
// //         if (i18nKeys.size > 0) {
// //           try {
// //             const modifiedCode = escodegen.generate(ast, {
// //               comment: true,
// //               format: {
// //                 indent: {
// //                   style: '  ',
// //                   base: 0
// //                 },
// //                 preserveBlankLines: true
// //               }
// //             });
// //             module._source._value = modifiedCode;
// //           } catch (error) {
// //             console.error(`Error generating code for ${module.resource}:`, error);
// //           }
// //         }
// //         return Array.from(i18nKeys);
// //       } catch (error) {
// //         console.error(`Error processing module ${module.resource}:`, error);
// //         return [];
// //       }
// //     }
// //     apply(compiler) {
// //       // Process modules during compilation
// //       compiler.hooks.compilation.tap('I18nPlugin', (compilation) => {
// //         // Process modules after they are loaded
// //         compilation.hooks.optimizeModules.tap('I18nPlugin', (modules) => {
// //           modules.forEach(module => {
// //             const keys = this.processModule(module);
// //             if (keys.length > 0) {
// //               // Update module to keys mapping
// //               this.moduleToKeysMap.set(module.resource, keys);
// //               // Update keys to modules mapping
// //               keys.forEach(key => {
// //                 if (!this.keyToModulesMap.has(key)) {
// //                   this.keyToModulesMap.set(key, new Set());
// //                 }
// //                 this.keyToModulesMap.get(key).add(module.resource);
// //               });
// //             }
// //           });
// //         });
// //         // Process chunks after optimization
// //         compilation.hooks.afterOptimizeChunks.tap('I18nPlugin', () => {
// //           this.processCollectedKeys(compilation);
// //         });
// //       });
// //     }
// //     processCollectedKeys(compilation) {
// //       // Map chunk IDs to sections and modules
// //       this.chunkIdToSectionsMap = {};
// //       this.moduleChunkIdToModulesMap = {};
// //       this.moduleResourceToChunkIds = new Map();
// //       // Process entry point modules
// //       const entryPointChunk = compilation.namedChunks.get(this.entryPointName);
// //       const entryPointModules = new Set();
// //       if (entryPointChunk) {
// //         for (const module of entryPointChunk.getModules()) {
// //           if (module.resource) {
// //             entryPointModules.add(module.resource);
// //           }
// //         }
// //       }
// //       // Process each chunk
// //       for (const chunk of compilation.chunks) {
// //         const chunkId = chunk.name || chunk.id;
// //         const chunkIdString = String(chunkId);
// //         const moduleResources = [];
// //         // Collect modules for this chunk
// //         for (const module of chunk.getModules()) {
// //           if (module.resource) {
// //             moduleResources.push(module.resource);
// //             // Map module resource to chunk IDs
// //             if (!this.moduleResourceToChunkIds.has(module.resource)) {
// //               this.moduleResourceToChunkIds.set(module.resource, new Set());
// //             }
// //             this.moduleResourceToChunkIds.get(module.resource).add(chunkIdString);
// //           }
// //         }
// //         // Store module resources for this chunk
// //         if (moduleResources.length > 0) {
// //           this.moduleChunkIdToModulesMap[chunkIdString] = moduleResources;
// //         }
// //       }
// //       // Collect used and unused keys
// //       this.collectKeyStats(entryPointModules);
// //       // Emit the i18n chunks
// //       this.emitI18nChunks(compilation);
// //     }
// //     collectKeyStats(entryPointModules) {
// //       // Collect all used keys
// //       this.allUsedKeys = new Set();
// //       for (const keys of this.moduleToKeysMap.values()) {
// //         for (const key of keys) {
// //           this.allUsedKeys.add(key);
// //         }
// //       }
// //       // Collect entry point keys
// //       this.entryPointKeys = new Set();
// //       for (const moduleResource of entryPointModules) {
// //         const keys = this.moduleToKeysMap.get(moduleResource);
// //         if (keys) {
// //           for (const key of keys) {
// //             this.entryPointKeys.add(key);
// //           }
// //         }
// //       }
// //       // Calculate remaining and unused keys
// //       this.allKeysInProperties = new Set(Object.keys(this.jsResourceI18nKeys));
// //       this.unusedKeys = new Set(
// //         [...this.allKeysInProperties].filter(key => !this.allUsedKeys.has(key))
// //       );
// //       this.remainingKeys = new Set(
// //         [...this.allUsedKeys].filter(key => !this.entryPointKeys.has(key))
// //       );
// //     }
// //     emitI18nChunks(compilation) {
// //       const manifest = {
// //         moduleToI18nChunkMap: {},
// //         locales: { default: {} }
// //       };
// //       // Map from i18nChunkId to keys
// //       const i18nChunkIdToKeysMap = {};
// //       let i18nChunkIdCounter = 0;
// //       // Entry Point Keys (Chunk 0)
// //       const entryPointChunkId = i18nChunkIdCounter++;
// //       i18nChunkIdToKeysMap[entryPointChunkId] = Array.from(this.entryPointKeys);
// //       for (const key of this.entryPointKeys) {
// //         this.keyToI18nChunkIdMap[key] = entryPointChunkId;
// //       }
// //       // Unused Keys
// //       const unusedKeysChunkId = 'unused';
// //       i18nChunkIdToKeysMap[unusedKeysChunkId] = Array.from(this.unusedKeys);
// //       // Process remaining keys into chunks
// //       const chunkSize = 100 * 1024; // 100KB chunks
// //       let currentChunk = [];
// //       let currentSize = 0;
// //       for (const key of this.remainingKeys) {
// //         const keySize = Buffer.byteLength(key, 'utf8') + 
// //                        Buffer.byteLength(this.jsResourceI18nKeys[key] || '', 'utf8');
// //         if (currentSize + keySize > chunkSize && currentChunk.length > 0) {
// //           // Save current chunk
// //           const chunkId = i18nChunkIdCounter++;
// //           i18nChunkIdToKeysMap[chunkId] = currentChunk;
// //           currentChunk.forEach(k => this.keyToI18nChunkIdMap[k] = chunkId);
// //           // Start new chunk
// //           currentChunk = [];
// //           currentSize = 0;
// //         }
// //         currentChunk.push(key);
// //         currentSize += keySize;
// //       }
// //       // Save last chunk if not empty
// //       if (currentChunk.length > 0) {
// //         const chunkId = i18nChunkIdCounter++;
// //         i18nChunkIdToKeysMap[chunkId] = currentChunk;
// //         currentChunk.forEach(k => this.keyToI18nChunkIdMap[k] = chunkId);
// //       }
// //       // Generate chunks
// //       for (const [i18nChunkId, keys] of Object.entries(i18nChunkIdToKeysMap)) {
// //         const i18nData = {};
// //         for (const key of keys) {
// //           const value = this.jsResourceI18nKeys[key];
// //           if (value !== undefined) {
// //             i18nData[this.getHash(key)] = value;
// //           }
// //         }
// //         if (Object.keys(i18nData).length > 0) {
// //           const chunkContent = `window.loadI18nChunk(${JSON.stringify(i18nData, null, 2)});`;
// //           const filename = `i18n-chunks/default/chunk-${i18nChunkId}.js`;
// //           compilation.emitAsset(filename, new RawSource(chunkContent));
// //           manifest.locales.default[i18nChunkId] = filename;
// //         }
// //       }
// //       // Build module to chunk mapping
// //       for (const [moduleChunkId, moduleResources] of Object.entries(this.moduleChunkIdToModulesMap)) {
// //         const requiredI18nChunkIds = new Set();
// //         for (const moduleResource of moduleResources) {
// //           const keys = this.moduleToKeysMap.get(moduleResource);
// //           if (keys) {
// //             for (const key of keys) {
// //               const i18nChunkId = this.keyToI18nChunkIdMap[key];
// //               if (i18nChunkId !== undefined) {
// //                 requiredI18nChunkIds.add(i18nChunkId);
// //               }
// //             }
// //           }
// //         }
// //         if (requiredI18nChunkIds.size > 0) {
// //           manifest.moduleToI18nChunkMap[moduleChunkId] = Array.from(requiredI18nChunkIds);
// //         }
// //       }
// //       // Ensure entry point has chunk zero
// //       manifest.moduleToI18nChunkMap[this.entryPointName] = 
// //         manifest.moduleToI18nChunkMap[this.entryPointName] || [];
// //       if (!manifest.moduleToI18nChunkMap[this.entryPointName].includes(entryPointChunkId)) {
// //         manifest.moduleToI18nChunkMap[this.entryPointName].unshift(entryPointChunkId);
// //       }
// //       // Emit manifest
// //       const manifestContent = 
// //         `window.i18n = window.i18n || {}; window.i18n.manifest = ${JSON.stringify(manifest, null, 2)};`;
// //       compilation.emitAsset('i18n-chunks/manifest.js', new RawSource(manifestContent));
// //     }
// //   }
// //   module.exports = I18nPlugin;
//   const NullFactory = require('webpack/lib/NullFactory');
// const { RawSource } = require('webpack-sources');
// const crypto = require('crypto');
// const { walk } = require('estree-walker');
// const parser = require('@babel/parser');
// const generate = require('@babel/generator').default;
// class I18nPlugin {
//   constructor(options = {}) {
//     const { jsResourcePath, mainChunkName, propertiesFolder, disableDefault, jsResource } = options;
//     if (!jsResourcePath) {
//       throw new Error('I18nPlugin: "jsResourcePath" option is required.');
//     }
//     if (!mainChunkName) {
//       throw new Error('I18nPlugin: "mainChunkName" option is required.');
//     }
//     this.jsResourcePath = jsResourcePath;
//     this.entryPointName = mainChunkName;
//     this.jsResourceI18nKeys = jsResource || {};
//     // Initialize collection maps
//     this.moduleToKeysMap = new Map();
//     this.keyToModulesMap = new Map();
//     this.keyToI18nChunkIdMap = {};
//     this.keyToHashMap = {};
//     // Initialize hash function
//     this.getHash = (key) => {
//       if (!this.keyToHashMap[key]) {
//         const hash = crypto.createHash('md5').update(key).digest('hex').substring(0, 8);
//         this.keyToHashMap[key] = hash;
//       }
//       return this.keyToHashMap[key];
//     };
//   }
//   shouldProcessModule(module) {
//     if (!module.resource) return false;
//     // Skip node_modules except for specific ones we want to process
//     if (module.resource.includes('node_modules')) {
//       const allowedModules = [
//         '@zohodesk'
//         // Add other allowed module prefixes here
//       ];
//       return allowedModules.some(prefix => 
//         module.resource.includes(`node_modules/${prefix}`)
//       );
//     }
//     // Process .js and .jsx files
//     return /\.(js|jsx)$/.test(module.resource);
//   }
//   processModule(module) {
//     if (!this.shouldProcessModule(module)) {
//       return [];
//     }
//     try {
//       const source = module._source._value;
//       // Parse with @babel/parser which handles modern JS better
//       const ast = parser.parse(source, {
//         sourceType: 'module',
//         plugins: [
//           'jsx',
//           'typescript',
//           'classProperties',
//           'decorators-legacy',
//           'exportDefaultFrom',
//           'exportNamespaceFrom',
//           'objectRestSpread',
//           'dynamicImport'
//         ]
//       });
//       const i18nKeys = new Set();
//       // Process the AST
//       walk(ast, {
//         enter: (node) => {
//           if (node.type === 'StringLiteral' && 
//               Object.prototype.hasOwnProperty.call(this.jsResourceI18nKeys, node.value)) {
//             const key = node.value;
//             i18nKeys.add(key);
//             const hash = this.getHash(key);
//             node.value = hash;
//             if (node.extra && node.extra.raw) {
//               node.extra.raw = `'${hash}'`;
//             }
//           }
//         }
//       });
//       // Generate modified code if keys were found
//       if (i18nKeys.size > 0) {
//         try {
//           const output = generate(ast, {
//             retainLines: true,
//             compact: false,
//             jsescOption: {
//               quotes: 'single'
//             }
//           });
//           module._source._value = output.code;
//         } catch (error) {
//           console.error(`Error generating code for ${module.resource}:`, error);
//         }
//       }
//       return Array.from(i18nKeys);
//     } catch (error) {
//       console.error(`Error processing module ${module.resource}:`, error);
//       return [];
//     }
//   }
//   apply(compiler) {
//     compiler.hooks.compilation.tap('I18nPlugin', (compilation) => {
//       // Process modules during compilation
//       compilation.hooks.optimizeModules.tap('I18nPlugin', (modules) => {
//         modules.forEach(module => {
//           const keys = this.processModule(module);
//           if (keys.length > 0) {
//             // Update module to keys mapping
//             this.moduleToKeysMap.set(module.resource, keys);
//             // Update keys to modules mapping
//             keys.forEach(key => {
//               if (!this.keyToModulesMap.has(key)) {
//                 this.keyToModulesMap.set(key, new Set());
//               }
//               this.keyToModulesMap.get(key).add(module.resource);
//             });
//           }
//         });
//       });
//       // Process chunks after optimization
//       compilation.hooks.afterOptimizeChunks.tap('I18nPlugin', () => {
//         this.processCollectedKeys(compilation);
//       });
//     });
//   }
//   processCollectedKeys(compilation) {
//     // Map chunk IDs to sections and modules
//     this.chunkIdToSectionsMap = {};
//     this.moduleChunkIdToModulesMap = {};
//     this.moduleResourceToChunkIds = new Map();
//     // Process entry point modules
//     const entryPointChunk = compilation.namedChunks.get(this.entryPointName);
//     const entryPointModules = new Set();
//     if (entryPointChunk) {
//       for (const module of entryPointChunk.getModules()) {
//         if (module.resource) {
//           entryPointModules.add(module.resource);
//         }
//       }
//     }
//     // Process each chunk
//     for (const chunk of compilation.chunks) {
//       const chunkId = chunk.name || chunk.id;
//       const chunkIdString = String(chunkId);
//       const moduleResources = [];
//       // Collect modules for this chunk
//       for (const module of chunk.getModules()) {
//         if (module.resource) {
//           moduleResources.push(module.resource);
//           // Map module resource to chunk IDs
//           if (!this.moduleResourceToChunkIds.has(module.resource)) {
//             this.moduleResourceToChunkIds.set(module.resource, new Set());
//           }
//           this.moduleResourceToChunkIds.get(module.resource).add(chunkIdString);
//         }
//       }
//       // Store module resources for this chunk
//       if (moduleResources.length > 0) {
//         this.moduleChunkIdToModulesMap[chunkIdString] = moduleResources;
//       }
//     }
//     // Collect used and unused keys
//     this.collectKeyStats(entryPointModules);
//     // Emit the i18n chunks
//     //this.emitI18nChunks(compilation);
//   }
//   collectKeyStats(entryPointModules) {
//     // Collect all used keys
//     this.allUsedKeys = new Set();
//     for (const keys of this.moduleToKeysMap.values()) {
//       for (const key of keys) {
//         this.allUsedKeys.add(key);
//       }
//     }
//     // Collect entry point keys
//     this.entryPointKeys = new Set();
//     for (const moduleResource of entryPointModules) {
//       const keys = this.moduleToKeysMap.get(moduleResource);
//       if (keys) {
//         for (const key of keys) {
//           this.entryPointKeys.add(key);
//         }
//       }
//     }
//     // Calculate remaining and unused keys
//     this.allKeysInProperties = new Set(Object.keys(this.jsResourceI18nKeys));
//     this.unusedKeys = new Set(
//       [...this.allKeysInProperties].filter(key => !this.allUsedKeys.has(key))
//     );
//     this.remainingKeys = new Set(
//       [...this.allUsedKeys].filter(key => !this.entryPointKeys.has(key))
//     );
//   }
//   emitI18nChunks(compilation) {
//     const manifest = {
//       moduleToI18nChunkMap: {},
//       locales: { default: {} }
//     };
//     // Map from i18nChunkId to keys
//     const i18nChunkIdToKeysMap = {};
//     let i18nChunkIdCounter = 0;
//     // Entry Point Keys (Chunk 0)
//     const entryPointChunkId = i18nChunkIdCounter++;
//     i18nChunkIdToKeysMap[entryPointChunkId] = Array.from(this.entryPointKeys);
//     for (const key of this.entryPointKeys) {
//       this.keyToI18nChunkIdMap[key] = entryPointChunkId;
//     }
//     // Unused Keys
//     const unusedKeysChunkId = 'unused';
//     i18nChunkIdToKeysMap[unusedKeysChunkId] = Array.from(this.unusedKeys);
//     // Process remaining keys into chunks
//     const chunkSize = 100 * 1024; // 100KB chunks
//     let currentChunk = [];
//     let currentSize = 0;
//     for (const key of this.remainingKeys) {
//       const keySize = Buffer.byteLength(key, 'utf8') + 
//                      Buffer.byteLength(this.jsResourceI18nKeys[key] || '', 'utf8');
//       if (currentSize + keySize > chunkSize && currentChunk.length > 0) {
//         // Save current chunk
//         const chunkId = i18nChunkIdCounter++;
//         i18nChunkIdToKeysMap[chunkId] = currentChunk;
//         currentChunk.forEach(k => this.keyToI18nChunkIdMap[k] = chunkId);
//         // Start new chunk
//         currentChunk = [];
//         currentSize = 0;
//       }
//       currentChunk.push(key);
//       currentSize += keySize;
//     }
//     // Save last chunk if not empty
//     if (currentChunk.length > 0) {
//       const chunkId = i18nChunkIdCounter++;
//       i18nChunkIdToKeysMap[chunkId] = currentChunk;
//       currentChunk.forEach(k => this.keyToI18nChunkIdMap[k] = chunkId);
//     }
//     // Generate chunks
//     for (const [i18nChunkId, keys] of Object.entries(i18nChunkIdToKeysMap)) {
//       const i18nData = {};
//       for (const key of keys) {
//         const value = this.jsResourceI18nKeys[key];
//         if (value !== undefined) {
//           i18nData[this.getHash(key)] = value;
//         }
//       }
//       if (Object.keys(i18nData).length > 0) {
//         const chunkContent = `window.loadI18nChunk(${JSON.stringify(i18nData, null, 2)});`;
//         const filename = `i18n-chunks/default/chunk-${i18nChunkId}.js`;
//         compilation.emitAsset(filename, new RawSource(chunkContent));
//         manifest.locales.default[i18nChunkId] = filename;
//       }
//     }
//     // Build module to chunk mapping
//     for (const [moduleChunkId, moduleResources] of Object.entries(this.moduleChunkIdToModulesMap)) {
//       const requiredI18nChunkIds = new Set();
//       for (const moduleResource of moduleResources) {
//         const keys = this.moduleToKeysMap.get(moduleResource);
//         if (keys) {
//           for (const key of keys) {
//             const i18nChunkId = this.keyToI18nChunkIdMap[key];
//             if (i18nChunkId !== undefined) {
//               requiredI18nChunkIds.add(i18nChunkId);
//             }
//           }
//         }
//       }
//       if (requiredI18nChunkIds.size > 0) {
//         manifest.moduleToI18nChunkMap[moduleChunkId] = Array.from(requiredI18nChunkIds);
//       }
//     }
//     // Ensure entry point has chunk zero
//     manifest.moduleToI18nChunkMap[this.entryPointName] = 
//       manifest.moduleToI18nChunkMap[this.entryPointName] || [];
//     if (!manifest.moduleToI18nChunkMap[this.entryPointName].includes(entryPointChunkId)) {
//       manifest.moduleToI18nChunkMap[this.entryPointName].unshift(entryPointChunkId);
//     }
//     // Emit manifest
//     const manifestContent = 
//       `window.i18n = window.i18n || {}; window.i18n.manifest = ${JSON.stringify(manifest, null, 2)};`;
//     compilation.emitAsset('i18n-chunks/manifest.js', new RawSource(manifestContent));
//   }
// }
// module.exports = I18nPlugin;
// const { RawSource } = require('webpack-sources');
// const { getAllI18nGroupedBySection, getPropertiesAsJSON, jsonToString } = require('../I18nSplitPlugin/utils/propertiesUtils');
// const { collectI18nKeysfromAST, collectI18nKeysfromComments,processModule } = require('../I18nSplitPlugin/utils/collectI18nKeys');
// const NullFactory = require('webpack/lib/NullFactory');
// const { I18nDependency, I18nDependencyTemplate } = require('../I18nSplitPlugin/I18nDependency');
// const I18nKeyHasher = require('./utils/I18nKeyHasher');
// const crypto = require('crypto');
// const pluginName = 'I18nSplitPlugin';
// const MODULE_TYPE = 'json/i18n';
// class I18nSplitPlugin {
//   constructor(options = {}) {
//     const {
//       jsResource,
//       localeVarName = 'document.documentElement.lang',
//       jsonpFunc = 'window.loadI18nChunk',
//       propertiesFolder,
//       disableDefault = false,
//       filenameTemplate = 'i18n-chunk/[locale]/[name].[chunkhash].i18n.js',
//       i18nManifestFileName = 'i18n-manifest.json',
//       mainChunkName = 'main'
//     } = options;
//     this.options = {
//       localeVarName,
//       jsonpFunc,
//       filenameTemplate,
//       i18nManifestFileName,
//       mainChunkName
//     };
//     // Load and initialize i18n data
//     this.jsResourceI18nKeys = jsResource ? getPropertiesAsJSON(jsResource) : {};
//     this.allI18nData = getAllI18nGroupedBySection({
//       folderPath: propertiesFolder,
//       disableDefault,
//       jsResourceI18nKeys: this.jsResourceI18nKeys
//     });
//     // Initialize key hasher
//     this.keyHasher = new I18nKeyHasher();
//     // Maps and tracking
//     this.moduleToKeysMap = new Map();
//     this.sectionToKeysMap = new Map();
//     this.keyToSectionMap = new Map();
//     this.sectionToChunkIdMap = new Map();
//     this.chunkToSectionsMap = new Map();
//     // Initialize sections and hashes
//     this.initializeMaps();
//     this.initializeHashes();
//     console.log('Locales found:', Object.keys(this.allI18nData));
//   }
//   initializeMaps() {
//     const firstLocale = Object.keys(this.allI18nData)[0];
//     if (!firstLocale) return;
//     const sections = this.allI18nData[firstLocale];
//     console.log(`Sections found: ${Object.keys(sections).join(', ')}`);
//     for (const [sectionName, sectionData] of Object.entries(sections)) {
//       const keys = Object.keys(sectionData);
//       this.sectionToKeysMap.set(sectionName, new Set(keys));
//       keys.forEach(key => this.keyToSectionMap.set(key, sectionName));
//     }
//   }
//   initializeHashes() {
//     const allKeys = new Set();
//     Object.values(this.allI18nData).forEach(localeData => {
//       Object.values(localeData).forEach(sectionData => {
//         Object.keys(sectionData).forEach(key => allKeys.add(key));
//       });
//     });
//     allKeys.forEach(key => {
//       this.keyHasher.hashKey(key);
//     });
//   }
//   apply(compiler) {
//     compiler.hooks.thisCompilation.tap(pluginName, (compilation, params) => {
//       // Set up dependencies
//       this.defineI18nDependency(compilation);
//       // Set up parsing
//       this.setupModuleParsing(compilation, params.normalModuleFactory);
//       // Process chunks after optimization
//       compilation.hooks.afterOptimizeChunks.tap(pluginName, () => {
//         this.processChunks(compilation);
//       });
//       // Emit assets
//       compiler.hooks.emit.tap(pluginName, () => {
//         this.emitAssets(compilation);
//       });
//     });
//   }
//   defineI18nDependency(compilation) {
//     compilation.dependencyFactories.set(I18nDependency, new NullFactory());
//     compilation.dependencyTemplates.set(I18nDependency, new I18nDependencyTemplate());
//   }
//   setupModuleParsing(compilation, factory) {
//     const handler = parser => {
//       parser.hooks.program.tap(pluginName, (ast, comments) => {
//         const { module } = parser.state;
//         if (!(module && /\.jsx?$/.test(module.resource))) return;
//         // Process the module and collect keys
//         const moduleKeys = processModule(module, this.jsResourceI18nKeys, this.keyHasher);
//         if (moduleKeys.length) {
//           // Store keys for chunk generation
//           this.moduleToKeysMap.set(module.resource, moduleKeys);
//           // Add dependency
//           this.addI18nDependency(module, moduleKeys);
//         }
//       });
//     };
//     factory.hooks.parser
//       .for('javascript/auto')
//       .tap(pluginName, handler);
//     factory.hooks.parser
//       .for('javascript/dynamic')
//       .tap(pluginName, handler);
//   }
//   addI18nDependency(module, keys) {
//     const dep = new I18nDependency({
//       identifier: `i18n ${module.resource}`,
//       i18nKeys: keys
//     }, module.context);
//     module.addDependency(dep);
//   }
//   processChunks(compilation) {
//     let chunkIdCounter = 0;
//     // Process entry point chunk
//     const entryChunk = compilation.namedChunks.get(this.options.mainChunkName);
//     if (entryChunk) {
//       const entryModules = Array.from(entryChunk.modulesIterable)
//         .filter(m => m.resource)
//         .map(m => m.resource);
//       // Collect entry point sections
//       const entrySections = new Set();
//       entryModules.forEach(moduleResource => {
//         const keys = this.moduleToKeysMap.get(moduleResource) || [];
//         keys.forEach(key => {
//           const section = this.keyToSectionMap.get(key);
//           if (section) entrySections.add(section);
//         });
//       });
//       // Assign chunk IDs to entry sections
//       entrySections.forEach(section => {
//         this.sectionToChunkIdMap.set(section, `section_${chunkIdCounter++}`);
//       });
//     }
//     // Process other chunks
//     for (const chunk of compilation.chunks) {
//       if (chunk === entryChunk) continue;
//       const modules = Array.from(chunk.modulesIterable)
//         .filter(m => m.resource);
//       const sectionsInChunk = new Set();
//       modules.forEach(module => {
//         const keys = this.moduleToKeysMap.get(module.resource) || [];
//         keys.forEach(key => {
//           const section = this.keyToSectionMap.get(key);
//           if (section) sectionsInChunk.add(section);
//         });
//       });
//       if (sectionsInChunk.size > 0) {
//         // Assign chunk IDs to new sections
//         sectionsInChunk.forEach(section => {
//           if (!this.sectionToChunkIdMap.has(section)) {
//             this.sectionToChunkIdMap.set(section, `section_${chunkIdCounter++}`);
//           }
//         });
//         this.chunkToSectionsMap.set(chunk, Array.from(sectionsInChunk));
//       }
//     }
//   }
//   emitAssets(compilation) {
//     const manifest = {
//       moduleToChunks: {},
//       hashMap: Object.fromEntries(this.keyHasher.keyHashMap),
//       locales: {}
//     };
//     // Generate chunks for each locale
//     for (const locale of Object.keys(this.allI18nData)) {
//       manifest.locales[locale] = {};
//       // Generate section chunks
//       for (const [section, chunkId] of this.sectionToChunkIdMap.entries()) {
//         const keys = this.sectionToKeysMap.get(section) || new Set();
//         const i18nData = {};
//         // Use hashed keys in chunks
//         keys.forEach(key => {
//           const hash = this.keyHasher.hashKey(key);
//           const value = this.allI18nData[locale][section]?.[key];
//           if (value) i18nData[hash] = value;
//         });
//         if (Object.keys(i18nData).length > 0) {
//           const chunkContent = `${this.options.jsonpFunc}(${jsonToString(i18nData)});`;
//           const fileName = this.getChunkFileName(chunkId, locale);
//           compilation.emitAsset(fileName, new RawSource(chunkContent));
//           manifest.locales[locale][chunkId] = fileName;
//         }
//       }
//     }
//     // Map modules to their required chunks
//     for (const [moduleResource, keys] of this.moduleToKeysMap.entries()) {
//       const requiredChunks = new Set();
//       keys.forEach(key => {
//         const section = this.keyToSectionMap.get(key);
//         if (section) {
//           const chunkId = this.sectionToChunkIdMap.get(section);
//           if (chunkId) requiredChunks.add(chunkId);
//         }
//       });
//       if (requiredChunks.size > 0) {
//         manifest.moduleToChunks[moduleResource] = Array.from(requiredChunks);
//       }
//     }
//     // Emit manifest
//     compilation.emitAsset(
//       this.options.i18nManifestFileName,
//       new RawSource(JSON.stringify(manifest, null, 2))
//     );
//     console.log(`Emitted manifest: ${this.options.i18nManifestFileName}`);
//   }
//   getChunkFileName(chunkId, locale) {
//     return this.options.filenameTemplate
//       .replace('[locale]', locale)
//       .replace('[name]', chunkId)
//       .replace('[chunkhash]', this.getContentHash(chunkId, locale));
//   }
//   getContentHash(chunkId, locale) {
//     return crypto
//       .createHash('md5')
//       .update(`${chunkId}_${locale}`)
//       .digest('hex')
//       .slice(0, 8);
//   }
// }
// module.exports = I18nSplitPlugin;
//const { getAllI18nGroupedBySection, getPropertiesAsJSON } = require('');
const {
  RawSource
} = require('webpack-sources');
const {
  getPropertiesAsJSON,
  jsonToString
} = require('../I18nSplitPlugin/utils/propertiesUtils');
const path = require('path');
const crypto = require('crypto');
const NullFactory = require('webpack/lib/NullFactory');
const {
  I18nDependency,
  I18nDependencyTemplate
} = require('../I18nSplitPlugin/I18nDependency');
class I18nPlugin {
  constructor(options = {}) {
    const {
      jsResource,
      localeVarName = 'document.documentElement.lang',
      jsonpFunc = 'window.loadI18nChunk',
      propertiesFolder,
      disableDefault = false,
      filenameTemplate = 'i18n-chunk/[locale]/[name].i18n.js',
      i18nManifestFileName = 'i18n-manifest.json',
      mainChunkName = 'main'
    } = options;
    this.options = {
      localeVarName,
      jsonpFunc,
      filenameTemplate,
      i18nManifestFileName,
      mainChunkName
    }; // Load i18n data

    this.jsResourceI18nKeys = jsResource ? getPropertiesAsJSON(jsResource) : {};
    this.propertiesFolder = propertiesFolder;
    this.disableDefault = disableDefault; // Track keys and chunks

    this.moduleKeys = new Map();
    this.chunkKeys = new Map();
    this.prevHashes = {};
  }
  apply(compiler) {
    // Main compilation hook
    compiler.hooks.thisCompilation.tap('I18nPlugin', compilation => {
      // Setup dependency handling
      compilation.dependencyFactories.set(I18nDependency, new NullFactory());
      compilation.dependencyTemplates.set(I18nDependency, new I18nDependencyTemplate()); // Parse modules for i18n keys

      const handler = parser => {
        parser.hooks.program.tap('I18nPlugin', (ast, comments) => {
          const {
            module
          } = parser.state; // Only process JS files

          if (!(module && /\.jsx?$/.test(module.resource))) {
            return;
          } // Collect keys from source

          const keys = this.collectKeys(ast, comments);
          if (keys.length) {
            this.moduleKeys.set(module, keys);
            this.addDependency(module, keys);
          }
        });
      }; // Register parser hooks

      compilation.normalModuleFactory.hooks.parser.for('javascript/auto').tap('I18nPlugin', handler);
      compilation.normalModuleFactory.hooks.parser.for('javascript/dynamic').tap('I18nPlugin', handler);
    }); // Emit hook for generating files

    compiler.hooks.emit.tap('I18nPlugin', compilation => {
      this.emitFiles(compilation);
    });
  }
  collectKeys(ast, comments) {
    const keys = new Set(); // Walk AST

    if (ast && ast.body) {
      const walk = node => {
        if (node.type === 'Literal' && typeof node.value === 'string') {
          if (this.jsResourceI18nKeys[node.value]) {
            keys.add(node.value);
          }
        }
        for (const key in node) {
          if (node[key] && typeof node[key] === 'object') {
            walk(node[key]);
          }
        }
      };
      ast.body.forEach(walk);
    } // Check comments

    if (comments) {
      comments.forEach(comment => {
        if (comment.value.includes('I18N:')) {
          const key = comment.value.split('I18N:')[1].trim();
          if (this.jsResourceI18nKeys[key]) {
            keys.add(key);
          }
        }
      });
    }
    return Array.from(keys);
  }
  addDependency(module, keys) {
    const dep = new I18nDependency({
      identifier: `i18n-${module.id}`,
      i18nKeys: keys
    }, module.context);
    module.addDependency(dep);
  }
  emitFiles(compilation) {
    // Generate manifest
    const manifest = {}; // Process chunks

    compilation.chunks.forEach(chunk => {
      const chunkKeys = new Set(); // Collect keys from chunk modules

      Array.from(chunk.modulesIterable).forEach(module => {
        const keys = this.moduleKeys.get(module) || [];
        keys.forEach(key => chunkKeys.add(key));
      });
      if (chunkKeys.size) {
        // Generate i18n files for each locale
        const locales = fs.readdirSync(this.propertiesFolder).filter(f => f.includes('_') && f.endsWith('.properties')).map(f => f.split('_')[1].split('.')[0]);
        locales.forEach(locale => {
          const i18nData = {};
          chunkKeys.forEach(key => {
            i18nData[key] = this.jsResourceI18nKeys[key];
          });
          const source = `${this.options.jsonpFunc}(${jsonToString(i18nData)});`;
          const filename = this.getFilename(chunk, locale);
          compilation.assets[filename] = new RawSource(source);
          if (!manifest[chunk.id]) {
            manifest[chunk.id] = {};
          }
          manifest[chunk.id][locale] = filename;
        });
      }
    }); // Emit manifest

    compilation.assets[this.options.i18nManifestFileName] = new RawSource(JSON.stringify(manifest, null, 2));
  }
  getFilename(chunk, locale) {
    return this.options.filenameTemplate.replace('[locale]', locale).replace('[name]', chunk.name || chunk.id).replace('[chunkhash]', chunk.contentHash['javascript']);
  }
}
module.exports = I18nPlugin;