"use strict";

var _path = _interopRequireDefault(require("path"));
var _fs = _interopRequireDefault(require("fs"));
var _fileUtils = require("./fileUtils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
let args = process.argv.slice(2);
let appPath = _fs.default.realpathSync(process.cwd());
let [targetPath] = args;
targetPath = targetPath === '."' || !targetPath ? '' : targetPath;
targetPath = _path.default.join(appPath, targetPath);
let srcPath = _path.default.resolve(_path.default.dirname(require.resolve('@zohodesk/datetimejs')), '../data/timezones/');
(0, _fileUtils.copy)(srcPath, targetPath, true, null, 'flatten');